力扣贪心题解 跳跃游戏

55. 跳跃游戏 - 力扣(LeetCode)

给你一个非负整数数组 nums ,你最初位于数组的 第一个下标 。数组中的每个元素代表你在该位置可以跳跃的最大长度。

判断你是否能够到达最后一个下标,如果可以,返回 true ;否则,返回 false 。

示例 1:

复制代码
输入:nums = [2,3,1,1,4]
输出:true
解释:可以先跳 1 步,从下标 0 到达下标 1, 然后再从下标 1 跳 3 步到达最后一个下标。

示例 2:

复制代码
输入:nums = [3,2,1,0,4]
输出:false
解释:无论怎样,总会到达下标为 3 的位置。但该下标的最大跳跃长度是 0 , 所以永远不可能到达最后一个下标。

提示:

  • 1 <= nums.length <= 104
  • 0 <= nums[i] <= 105

题解

题目描述给定了一个非负整数数组nums,其中数组中的每个元素表示再该位置的最大跳跃长度,目的是判断是否能从第一个下标到达最后一个下标。

贪心算法非常适合这个问题,这道题的方法是遍历数组,并在每一步中根据当前位置和当前位置的跳跃长度更新最大可到达的下标。在任何一步遍历中,如果最大可达的下标超过或等于最后一个下标,则答案为true。如果迭代结束没有到达最后一个下标,则答案为false。

cpp 复制代码
class Solution {
public:
    bool canJump(vector<int>& nums) {
        int maxReach = 0;   // 最远能到达的位置
        for(int i = 0; i < nums.szie(); ++i){
            if(i > maxReach) return false;  // 如果当前位置已经超过了最远能到达的位置,就返回false
        }
        // 更新最远能到达的位置
        maxReach = max(maxReach, nums[i] + i);
        if(maxReach >= nums.size() - 1) return true;  // 如果最远能到达的位置已经超过了数组的长度,就返回true
    }
};

45. 跳跃游戏 II - 力扣(LeetCode)

给定一个长度为 n 的 0 索引 整数数组 nums。初始位置为 nums[0]。

每个元素 nums[i] 表示从索引 i 向前跳转的最大长度。换句话说,如果你在 nums[i] 处,你可以跳转到任意 nums[i + j] 处:

  • 0 <= j <= nums[i]
  • i + j < n

返回到达 nums[n - 1] 的最小跳跃次数。生成的测试用例可以到达 nums[n - 1]。

示例 1:

复制代码
输入: nums = [2,3,1,1,4]
输出: 2
解释: 跳到最后一个位置的最小跳跃数是 2。
     从下标为 0 跳到下标为 1 的位置,跳 1 步,然后跳 3 步到达数组的最后一个位置。

示例 2:

复制代码
输入: nums = [2,3,0,1,4]
输出: 2

提示:

  • 1 <= nums.length <= 104
  • 0 <= nums[i] <= 1000
  • 题目保证可以到达 nums[n-1]

题解

这个题是上一个题的进阶版,它指在上题的基础上要求你找从第一个下标到最后一个下标所需跳跃的最小次数。

同样使用贪心的方法来解决,思路是记录每一次迭代可到达的范围,直到到达数组的最后一个下标。

同时引入两个变量:

  • currentEnd:记录每一次跳跃前下标的跳跃边界
  • farthest:记录跳跃的最远距离

每一次遍历,我们都更新farthest为自身和当前下标i+nums[i]的最大值。这表示从当前位置可以到达的最大下标。

如果i达到currentEnd,则表明我们已经到达当前跳跃的边界,因为我们增加跳跃次数(+1)并将currentEnd设置为farthest。这是我们在下一次跳跃中可以到达的位置范围。

更新currentEnd后,如果currentEnd大于等于末尾,我们就不需要继续遍历了

cpp 复制代码
class Solution {
public:
    int jump(vector<int>& nums) {
        int jumps = 0;   // 跳跃次数
        int currentEnd = 0;  // 当前跳跃的边界
        int farthest = 0;   // 最远能跳到的位置
        if(nums.size() == 1) return 0;  // 如果数组长度为1,就不用跳了,直接返回0

        for(int i = 0; i < nums.size() - 1; ++i){
            farthest = max(nums[i] + i, farthest);  // 更新最远能跳到的位置
            if(i == currentEnd){  // 遇到边界,就更新边界,并且步数加一
                currentEnd = farthest;
                ++jumps;
                if(currentEnd >= nums.size() - 1) return jumps;  // 如果当前边界已经超过了数组的长度,就不用再继续计算了
            }
        }
        return jumps;
    }
};
相关推荐
一去不复返的通信er3 小时前
力扣-图论-岛屿数量
算法·leetcode·图论
程序 代码狂人6 小时前
切片表与分区表的区别(数据开发面试版)
java·大数据·开发语言·数据仓库·算法
HDU-Dade6 小时前
【校招笔试真题】简要介绍 Self-Attention 的前沿算法
人工智能·算法
装备研究社7 小时前
对峙2掉线排查实测
游戏
Xin7707 小时前
LeetCode 79. 单词搜索(DFS 回溯法)
leetcode
xcLeigh8 小时前
Unity基础:Destroy与DestroyImmediate——正确销毁游戏物体的方式
游戏·unity·游戏引擎·教程
sunxfancy8 小时前
EVEngine 0.6 到 0.6.1:让 AI 参与游戏开发,还需要补上哪些环节?
游戏
小郎君6589 小时前
Vue keep-alive 切标签后滚动位置回顶?因为 onDeactivated 里读到的 scrollTop 是 0
算法
邵奈一9 小时前
GPT-6.1 Terra速度是Sol的3倍,价格减半
算法
RaaS1009 小时前
Node.js Brotli RCE 漏洞自查指南:fetch、undici、axios 都在影响面,三分钟确认你的版本
人工智能·深度学习·算法